#include "Tree.h"

#include <qprogdlg.h> 
#include <qstring.h>
#include <qfile.h>
#include <qtstream.h>
#include <qregexp.h>
#include <qdatetm.h>

class Generator
{
 public:
  Generator(int val,QWidget *widget, QString home, QString sys);
  ~Generator() {};
  bool generateSource(MyTree *t);
  void finishSource(QString homename, QString whatname, QString name);
  void copyFile(QString dfilename, QString sfilename);
  void removeSpace(QString dfilename, QString sfilename);
  void addImport(QString filename);
  void addImplements(QString filename);
  void genHtml(MyTree* t);

 private:
  int max,counter;
  int tmpcounter;
  bool first;
  int l1, l2, l3, l4;
  QString boxgroups[10];
  QString canvastab[20];
  QString listenertab[11];
  QString targetname;
  QString tmp_label,homeDir,sysDir;
  int numgroups;
  int numcanvas;
  QProgressDialog *progress;
  bool listener[11];

  int getFileLines(QString filename);
  void template2Source(QString dfilename, QString sfilename, int n, QString arg[], bool ap);
  void concateFiles(QString name1, QString name2, bool append); 
  void insertFile(QString dest, QString source1, QString source2, int line); 
  void insertBuffer(QString dfilename, QString sfilename, QString *buf, int line); 
  QString getTmpName(bool changecounter, QString *s);
  bool isCheckBoxGroup(QString name);
  void addNewCheckBoxGroup(QString name);
  void addNewCanvas(QString name);
  void setTargetName(QString name) {targetname = name.copy();}
  QString getTargetName() {return targetname.data(); }
  QString getHigherMenu(MyTree *t, char* name, int num);
  void addListener(MyTree *t, QString f1name, QString f2name, QString varname, int &line);
  void updateListener(QString name, bool tab[]);
  QString replaceMarks(QString *b, int n, QString rep[]);
  void importHelp(QString filename, QString name);
  void implementsHelp(QString filename, QString name);

  void genAddCanvas();
  void genApplet(MyTree *t);
  void genFrame(MyTree *t);
  void genWindow(MyTree *t);
  void genPushButton(MyTree *t);
  void genCheckbox(MyTree *t);
  void genScrollbar(MyTree *t);  
  void genLabel(MyTree *t);
  void genChoice(MyTree *t);
  void genCanvas(MyTree *t);
  void genList(MyTree *t);
  void genTextField(MyTree *t);
  void genTextArea(MyTree *t);
  void genMenuBar(MyTree *t);
  void genMenu(MyTree *t);
  void genMenuItem(MyTree *t, QString higher);
  void genCheckboxMenuItem(MyTree *t, QString higher);
  void genSubMenu(MyTree *t, QString higher);
  void genComment(QString homename, QString name);
};
